import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

class MenuList
    extends List
    implements CommandListener
{
	final private Twister midlet;
    final private Command exitCommand;
    private boolean hasRetry = false;
    private boolean hasContinue = false;

    // first time: no extra items
    // after solve: retry
    // in middle: continue/restart/solve
    
    public MenuList(Twister midlet)
    {
        super("Twister", List.IMPLICIT);
        this.midlet = midlet;

        append("New game", null);
        append("Instructions", null);
        append("Settings", null);

        exitCommand = new Command("Exit", Command.EXIT, 1);
        addCommand(exitCommand);
        
        setCommandListener(this);
    }


    public void setGameRetry()
    {
    	String s = "Retry";
        if( hasContinue  ){
        	set( 0, s, null );
        	delete(2);
        	delete(1);
        }else if( !hasRetry ){
            insert(0, s, null);
        }
        hasRetry = true;
        hasContinue = false;
    }
    public void setGameContinue()
    {
    	String s = "Continue";
        if( hasRetry  ){
        	set( 0, s, null );
        }else if( !hasContinue ){
            insert(0, s, null);
        }
        if( !hasContinue ){
        	insert(1, "Restart", null);
        	insert(2, "Solve", null);
        }
        hasRetry = false;
        hasContinue = true;
    }

    public void commandAction(Command c, Displayable d)
    {
        if (c == List.SELECT_COMMAND)
        {
            int index = getSelectedIndex();
            if (index != -1)  // should never be -1
            {
                if ( hasRetry ){
                    switch (index){
                    case 0: midlet.menuListRetry(); break;
                    case 1: midlet.menuListNewGame(); break;
                    case 2: midlet.menuListInstructions(); break;
                    case 3: midlet.menuListSettings(); break;
                    default: break;
                    }
                } else if( hasContinue ){
                    switch (index){
                    case 0: midlet.menuListContinue(); break;
                    case 1: midlet.menuListRetry(); break;
                    case 2: midlet.menuListSolve(); break;
                    case 3: midlet.menuListNewGame(); break;
                    case 4: midlet.menuListInstructions(); break;
                    case 5: midlet.menuListSettings(); break;
                    default: break;
                    }
                }else{
                    switch (index){
                    case 0: midlet.menuListNewGame(); break;
                    case 1: midlet.menuListInstructions(); break;
                    case 2: midlet.menuListSettings(); break;
                    default: break;
                    }
                }
            }
        }
        else if (c == exitCommand)
        {
            midlet.menuListQuit();
        }
    }
}
