
public class Queue {
	private byte queue[] = new byte[30];
	private int first = 0, last = 0;

	synchronized public boolean isEmpty(){
		return last == first;
	}
	synchronized public int size(){
		return first<=last ? last-first : queue.length + last-first;
	}
	synchronized public void clear(){
		first = last = 0;
	}
	
	synchronized public void add( int m ){
		if( isFull() ) expand();
		queue[last] = (byte)m;
		last++;
		if( last == queue.length ) last = 0;
	}
	synchronized public int pop(){
		if( isEmpty() ) return -1;
		int m = queue[first];
		first++;
		if( first == queue.length ) first = 0;
		return m;
	}


	private boolean isFull(){
		return last == first-1 || last == first+queue.length-1;
	}
	private void expand(){
		byte[] newqueue = new byte[queue.length*2];
		int c=0;
		while( !isEmpty() ){
			newqueue[c] = (byte) pop();
			c++;
		}
		queue = newqueue;
		first = 0;
		last = c;
	}
}
