import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Gauge;
import javax.microedition.lcdui.Form;

public class SettingsForm extends Form
	implements CommandListener
{
	final private Gauge AnimFramesItem = new Gauge("Animation Frames", true, 20, 10);
	final private Gauge solvingSpeedItem = new Gauge("Solving speed", true, 10, 3);
	final private Gauge shufflingSpeedItem = new Gauge("Shuffling speed", true, 10, 2);
	final private Twister parent;
    final private Command exitCommand;
	
	public SettingsForm( Twister c ){
		super("Settings");
		parent = c;

		append( AnimFramesItem );
		append( solvingSpeedItem );	
		append( shufflingSpeedItem );

		exitCommand = new Command("Exit", Command.EXIT, 1);
        addCommand(exitCommand);
        setCommandListener(this);
	}

	public void setValues( int animFrames, int shufflingSpeed, int solvingSpeed ){
		AnimFramesItem.setValue( animFrames );
		solvingSpeedItem.setValue( solvingSpeed );
		shufflingSpeedItem.setValue( shufflingSpeed );
	}
    public void commandAction(Command c, Displayable d)
    {
        if (c == exitCommand)
        {
            parent.settingsFormExit();
        }
    }

	public int getAnimFrames(){ return AnimFramesItem.getValue(); }
	public int getShufflingSpeed(){ return shufflingSpeedItem.getValue(); }
	public int getSolvingSpeed(){ return solvingSpeedItem.getValue(); }
}
